import { defineComponent as K, getCurrentInstance as q, ref as y, onMounted as L, onBeforeUnmount as b, onUpdated as G, watch as O, nextTick as H, openBlock as W, createElementBlock as $, useAttrs as J } from "vue";
import * as r from "plotly.js-dist-min";
import { useResizeObserver as Q } from "@vueuse/core";
const X = [
  "plotly_afterexport",
  "plotly_afterplot",
  "plotly_animated",
  "plotly_animating",
  "plotly_animatingframe",
  "plotly_animationinterrupted",
  "plotly_autosize",
  "plotly_beforeexport",
  "plotly_beforehover",
  "plotly_beforeplot",
  "plotly_buttonclicked",
  "plotly_click",
  "plotly_clickannotation",
  "plotly_deselect",
  "plotly_doubleclick",
  "plotly_framework",
  "plotly_hover",
  "plotly_legendclick",
  "plotly_legenddoubleclick",
  "plotly_react",
  "plotly_redraw",
  "plotly_relayout",
  "plotly_relayouting",
  "plotly_restyle",
  "plotly_selected",
  "plotly_selecting",
  "plotly_sliderchange",
  "plotly_sliderend",
  "plotly_sliderstart",
  "plotly_transitioned",
  "plotly_transitioning",
  "plotly_transitioninterrupted",
  "plotly_unhover",
  "plotly_update",
  "plotly_webglcontextlost"
], _ = X.map((t) => ({
  eventName: t,
  handler(e) {
    return (...a) => {
      e.emit.apply(e, [t, ...a]);
    };
  }
})), Y = (t) => {
  if (!t.value || t.value.tagName)
    throw Error("plotlyRoot is undefined.");
  return {
    /* * * DANGER * * * Do not hand edit the code below! * * * DANGER * * */
    plotlyNewPlot(...e) {
      return r.newPlot(t.value, ...e);
    },
    plotlyRestyle(...e) {
      return r.restyle(t.value, ...e);
    },
    plotlyRelayout(...e) {
      return r.relayout(t.value, ...e);
    },
    plotlyRedraw(...e) {
      return r.redraw(t.value, ...e);
    },
    plotlyUpdate(...e) {
      return r.update(t.value, ...e);
    },
    plotlyReact(...e) {
      return r.react(t.value, ...e);
    },
    plotlyExtendTraces(...e) {
      return r.extendTraces(t.value, ...e);
    },
    plotlyPrependTraces(...e) {
      return r.prependTraces(t.value, ...e);
    },
    plotlyAddTraces(...e) {
      return r.addTraces(t.value, ...e);
    },
    plotlyDeleteTraces(...e) {
      return r.deleteTraces(t.value, ...e);
    },
    plotlyMoveTraces(...e) {
      return r.moveTraces(t.value, ...e);
    },
    plotlyPurge(...e) {
      return r.purge(t.value, ...e);
    },
    plotlyAddFrames(...e) {
      return r.addFrames(t.value, ...e);
    },
    plotlyDeleteFrames(...e) {
      return r.deleteFrames(t.value, ...e);
    },
    plotlyAnimate(...e) {
      return r.animate(t.value, ...e);
    },
    plotlySetPlotConfig(...e) {
      return r.setPlotConfig(t.value, ...e);
    },
    plotlyToImage(...e) {
      return r.toImage(t.value, ...e);
    },
    plotlyValidate(...e) {
      return r.validate(t.value, ...e);
    },
    plotlyDownloadImage(...e) {
      return r.downloadImage(t.value, ...e);
    },
    plotlyMakeTemplate(...e) {
      return r.makeTemplate(t.value, ...e);
    },
    plotlyValidateTemplate(...e) {
      return r.validateTemplate(t.value, ...e);
    }
    /* * * DANGER * * * Do not hand edit the code above! * * * DANGER * * */
  };
};
function Z(t) {
  const e = /* @__PURE__ */ Object.create(null);
  return function(o) {
    return e[o] || (e[o] = t(o));
  };
}
const B = /-(\w)/g, R = Z((t) => t.replace(B, (e, a) => a ? a.toUpperCase() : ""));
function D(t, e) {
  const a = Object.keys, o = Array.isArray, n = typeof t, i = typeof e, m = t && e && o(t) && o(e), g = t && !o(t) && e && !o(e);
  return n === "object" && ((m || g) && n === i) ? (m ? t.length === e.length : a(t).length === a(e).length) && a({ ...t, ...e }).every((v) => D(t[v], e[v])) : t === e;
}
const j = ["id"], ye = /* @__PURE__ */ K({
  __name: "Plotly",
  props: {
    data: Array,
    layout: Object,
    id: {
      type: String,
      required: !1,
      default: null
    }
  },
  emits: _.map((t) => t.eventName),
  setup(t, { expose: e }) {
    const a = t, o = q();
    if (!o)
      throw Error("Bad component initialization");
    const n = y({}), i = Y(n), {
      plotlyAddFrames: m,
      plotlyAddTraces: g,
      plotlyAnimate: E,
      plotlyDeleteFrames: v,
      plotlyDeleteTraces: ee,
      plotlyDownloadImage: I,
      plotlyExtendTraces: te,
      plotlyMakeTemplate: le,
      plotlyMoveTraces: re,
      plotlyNewPlot: x,
      plotlyPrependTraces: ae,
      plotlyPurge: A,
      plotlyReact: F,
      plotlyRedraw: ne,
      plotlyRelayout: z,
      plotlyRestyle: oe,
      plotlySetPlotConfig: ue,
      plotlyToImage: C,
      plotlyUpdate: se,
      plotlyValidate: pe,
      plotlyValidateTemplate: ie
    } = i;
    Object.entries(i).forEach(([l, u]) => 0), e({ ...i, plotlyRoot: n, toImage: S, downloadImage: U });
    const p = y(null), c = y({ ...a.layout }), M = 100;
    let h = 0;
    const N = () => {
      const l = h + M - Date.now();
      l <= 0 ? T() : setTimeout(T, l);
    }, T = () => {
      h = Date.now(), r.Plots.resize(n.value);
    }, w = () => {
      const l = J();
      return {
        responsive: !1,
        ...Object.keys(l).reduce((s, k) => (s[R(k)] = l[k], s), {})
      };
    }, d = y(w());
    L(() => {
      x(a.data || [], c.value, d.value), _.forEach((l) => {
        n.value && n.value.on(l.eventName, l.handler(o));
      }), Q(n, N);
    }), b(() => {
      _.forEach((l) => {
        n.value && n.value.removeAllListeners(l.eventName);
      }), A();
    }), G(() => {
      const l = w();
      D(d.value, l) || (d.value = l, f({ replot: !0 }));
    }), O(
      () => a.data,
      () => f({ replot: !0 }),
      { deep: !0 }
    ), O(
      () => a.layout,
      () => {
        c.value = { ...a.layout }, f({ replot: !1 });
      }
    );
    function f(l) {
      if (p.value) {
        p.value.replot = p.value.replot || l.replot;
        return;
      }
      p.value = l, H(() => {
        var s;
        const u = (s = p.value) == null ? void 0 : s.replot;
        if (p.value = null, u) {
          V();
          return;
        }
        z(c.value);
      });
    }
    function S(l) {
      const u = Object.assign(P(), l);
      return C(u);
    }
    function U(l) {
      const u = `plot--${(/* @__PURE__ */ new Date()).toISOString().replace(/\.[0-9]+/, "")}`, s = Object.assign(P(), { filename: u }, l);
      return I(s);
    }
    function P() {
      return {
        format: "png",
        width: n.value.clientWidth,
        height: n.value.clientHeight
      };
    }
    function V() {
      F(a.data || [], c.value, d.value);
    }
    return (l, u) => (W(), $("div", {
      id: t.id,
      ref_key: "plotlyRoot",
      ref: n
    }, null, 8, j));
  }
}), me = { name: "vue-plotly", version: "2.0.0-rc5" };
export {
  me as PACKAGE,
  ye as default,
  X as eventNames
};
//# sourceMappingURL=vue-plotly.mjs.map
